diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
index f71d51782..d518830a0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -1,7 +1,10 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.BlockLogicFallingBlock;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.BiomeTags;
@@ -11,12 +14,16 @@ import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
 
 import java.util.Random;
 
 public class ChunkDecoratorOverworldB173
     implements ChunkDecorator {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
+
     private final @NotNull World world;
     private final @NotNull FractalNoise2D<ImprovedPerlinNoise> forestNoise;
 
@@ -34,6 +41,8 @@ public class ChunkDecoratorOverworldB173
         final int x = chunk.pos.x;
         final int z = chunk.pos.z;
 
+        try {
+
         final int minY = this.world.getWorldType().getMinY(world);
         final int maxY = this.world.getWorldType().getMaxY(world);
         final int rangeY = (maxY + 1) - minY;
@@ -50,6 +59,7 @@ public class ChunkDecoratorOverworldB173
 
         rand.setSeed(rx * x + rz * z ^ this.world.getRandomSeed());
 
+        try {
         if (rand.nextInt(4) == 0) {
             final int fx = wx + rand.nextInt(16) + 8;
             final int fy = rand.nextInt(rangeY);
@@ -65,7 +75,9 @@ public class ChunkDecoratorOverworldB173
                 new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id()).place(this.world, rand, fx, fy, fz);
             }
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'lakes' failed at chunk ({}, {}); continuing.", x, z, t); }
 
+        try {
         for (int i = 0; i < 8; i++) {
             final int fx = wx + rand.nextInt(16) + 8;
             final int fy = rand.nextInt(rangeY);
@@ -84,58 +96,68 @@ public class ChunkDecoratorOverworldB173
             final int fx = wx + rand.nextInt(16);
             final int fy = rand.nextInt(rangeY);
             final int fz = wz + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.DIRT.id(), 32).place(this.world, rand, fx, fy, fz);
+            final TilePos queryPos = new TilePos(fx, fy, fz);
+            new WorldFeatureOre(Blocks.DIRT.id(), 32).place(this.world, rand, queryPos);
         }
 
         for (int i = 0; i < 10; i++) {
             final int fx = wx + rand.nextInt(16);
             final int fy = rand.nextInt(rangeY);
             final int fz = wz + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.GRAVEL.id(), 32).place(this.world, rand, fx, fy, fz);
+            final TilePos queryPos = new TilePos(fx, fy, fz);
+            new WorldFeatureOre(Blocks.GRAVEL.id(), 32).place(this.world, rand, queryPos);
         }
 
         for (int i = 0; i < 20; i++) {
             final int fx = wx + rand.nextInt(16);
             final int fy = rand.nextInt(rangeY);
             final int fz = wz + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.ORE_COAL_STONE.id(), 16).place(this.world, rand, fx, fy, fz);
+            final TilePos queryPos = new TilePos(fx, fy, fz);
+            new WorldFeatureOre(Blocks.ORE_COAL_STONE.id(), 16).place(this.world, rand, queryPos);
         }
 
         for (int i = 0; i < 20; i++) {
             final int fx = wx + rand.nextInt(16);
             final int fy = rand.nextInt(rangeY / 2);
             final int fz = wz + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.ORE_IRON_STONE.id(), 8).place(this.world, rand, fx, fy, fz);
+            final TilePos queryPos = new TilePos(fx, fy, fz);
+            new WorldFeatureOre(Blocks.ORE_IRON_STONE.id(), 8).place(this.world, rand, queryPos);
         }
 
         for (int i = 0; i < 2; i++) {
             final int fx = wx + rand.nextInt(16);
             final int fy = rand.nextInt(rangeY / 4);
             final int fz = wz + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.ORE_GOLD_STONE.id(), 8).place(this.world, rand, fx, fy, fz);
+            final TilePos queryPos = new TilePos(fx, fy, fz);
+            new WorldFeatureOre(Blocks.ORE_GOLD_STONE.id(), 8).place(this.world, rand, queryPos);
         }
 
         for (int i = 0; i < 8; i++) {
             final int fx = wx + rand.nextInt(16);
             final int fy = rand.nextInt(rangeY / 8);
             final int fz = wz + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.ORE_REDSTONE_STONE.id(), 7).place(this.world, rand, fx, fy, fz);
+            final TilePos queryPos = new TilePos(fx, fy, fz);
+            new WorldFeatureOre(Blocks.ORE_REDSTONE_STONE.id(), 7).place(this.world, rand, queryPos);
         }
 
         for (int i = 0; i < 1; i++) {
             final int fx = wx + rand.nextInt(16);
             final int fy = rand.nextInt(rangeY / 16);
             final int fz = wz + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.ORE_DIAMOND_STONE.id(), 7).place(this.world, rand, fx, fy, fz);
+            final TilePos queryPos = new TilePos(fx, fy, fz);
+            new WorldFeatureOre(Blocks.ORE_DIAMOND_STONE.id(), 7).place(this.world, rand, queryPos);
         }
 
         for (int i = 0; i < 1; i++) {
             final int fx = wx + rand.nextInt(16);
             final int fy = rand.nextInt(rangeY / 16) + rand.nextInt(rangeY / 16);
             final int fz = wz + rand.nextInt(16);
-            new WorldFeatureOre(Blocks.ORE_LAPIS_STONE.id(), 6).place(this.world, rand, fx, fy, fz);
+            final TilePos queryPos = new TilePos(fx, fy, fz);
+            new WorldFeatureOre(Blocks.ORE_LAPIS_STONE.id(), 6).place(this.world, rand, queryPos);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'ores_dungeons_clay' failed at chunk ({}, {}); continuing.", x, z, t); }
 
+        try {
         final double forestNoiseScale = 0.5;
         final int forestNoiseValue = (int) ((this.forestNoise.getValue(wx * forestNoiseScale, wz * forestNoiseScale) / 8.0 + rand.nextDouble() * 4.0 + 4.0) / 3.0);
         int numTrees = 0;
@@ -167,13 +189,19 @@ public class ChunkDecoratorOverworldB173
         }
 
         for (int i = 0; i < numTrees; i++) {
-            final int fx = wx + rand.nextInt(16) + 8;
-            final int fz = wz + rand.nextInt(16) + 8;
-            final @NotNull WorldFeature feature = biome.getTreeFeature(rand);
-            feature.init(1.0, 1.0, 1.0);
-            biome.getTreeFeature(rand).place(this.world, rand, fx, this.world.getHeightValue(fx, fz), fz);
+            try {
+                final int fx = wx + rand.nextInt(16) + 8;
+                final int fz = wz + rand.nextInt(16) + 8;
+                final @NotNull WorldFeature feature = biome.getTreeFeature(rand);
+                feature.init(1.0, 1.0, 1.0);
+                biome.getTreeFeature(rand).place(this.world, rand, fx, this.world.getHeightValue(fx, fz), fz);
+            } catch (final Throwable treeT) {
+                LOGGER.error("Tree placement #{} failed at chunk ({}, {}); continuing.", i, x, z, treeT);
+            }
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'trees' failed at chunk ({}, {}); continuing.", x, z, t); }
 
+        try {
         int numYellowFlowers = 0;
         if (biome == Biomes.OVERWORLD_LEGACY_FOREST) {
             numYellowFlowers += 2;
@@ -296,25 +324,67 @@ public class ChunkDecoratorOverworldB173
             final int fz = wz + rand.nextInt(16) + 8;
             new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id()).place(this.world, rand, fx, fy, fz);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'plants_liquids' failed at chunk ({}, {}); continuing.", x, z, t); }
 
         final int oceanY = this.world.getWorldType().getOceanY();
-        for (int xx = x + 8; xx < x + 8 + 16; xx++) {
-            for (int zz = z + 8; zz < z + 8 + 16; zz++) {
-                int yy = this.world.getHeightValue(xx, zz);
-                final Biome localBiome = this.world.getBlockBiome(xx, yy, zz);
-
-                if (localBiome.hasTag(BiomeTags.HAS_SURFACE_SNOW) && yy > 0 && yy < this.world.getHeightBlocks()) {
-                    if (this.world.isAirBlock(xx, yy, zz) && this.world.getBlockMaterial(xx, yy - 1, zz).blocksMotion()) {
-                        this.world.setBlockWithNotify(xx, yy, zz, Blocks.LAYER_SNOW.id());
+        try {
+            for (int xx = wx + 8; xx < wx + 8 + 16; xx++) {
+                for (int zz = wz + 8; zz < wz + 8 + 16; zz++) {
+                    try {
+                        applySnowAndIceForColumn(xx, zz, oceanY);
+                    } catch (final Throwable colT) {
+                        LOGGER.error("Snow/ice column ({}, {}) failed at chunk ({}, {}); continuing.", xx, zz, x, z, colT);
                     }
                 }
-                if (localBiome.hasTag(BiomeTags.HAS_SURFACE_ICE) && (this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_FLOWING.id())) {
-                    this.world.setBlockWithNotify(xx, oceanY - 1, zz, Blocks.ICE.id());
+            }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'snow_ice' failed at chunk ({}, {}); continuing.", x, z, t); }
+
+        //resnow pass
+        try {
+            for (int dx = wx; dx < wx + 32; dx++) {
+                for (int dz = wz; dz < wz + 32; dz++) {
+                    final int ownerChunkX = (dx - 8) >> 4;
+                    final int ownerChunkZ = (dz - 8) >> 4;
+                    if (ownerChunkX == x && ownerChunkZ == z) { continue; }
+                    if (!this.world.isChunkLoaded(ownerChunkX, ownerChunkZ)) { continue; }
+                    final Chunk owner = this.world.getChunkFromChunkCoords(ownerChunkX, ownerChunkZ);
+                    if (!owner.isTerrainPopulated) { continue; }
+                    final int physicalChunkX = dx >> 4;
+                    final int physicalChunkZ = dz >> 4;
+                    if (!this.world.isChunkLoaded(physicalChunkX, physicalChunkZ)) { continue; }
+                    try {
+                        applySnowAndIceForColumn(dx, dz, oceanY);
+                    } catch (final Throwable colT) {
+                        LOGGER.error("Spillover snow/ice column ({}, {}) failed at chunk ({}, {}); continuing.", dx, dz, x, z, colT);
+                    }
                 }
             }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'snow_ice_spillover' failed at chunk ({}, {}); continuing.", x, z, t); }
+
+        } finally {
+            BlockLogicFallingBlock.fallInstantly = false;
+            this.world.scheduledUpdatesAreImmediate = false;
         }
+    }
+
+    /**
+     * Places snow on the topmost surface of the column, plus ice on top of water at the ocean surface.
+     */
+    private void applySnowAndIceForColumn(final int xx, final int zz, final int oceanY) {
+        final int yy = this.world.getHeightValue(xx, zz);
+        final Biome localBiome = this.world.getBlockBiome(xx, yy, zz);
 
-        BlockLogicFallingBlock.fallInstantly = false;
-        this.world.scheduledUpdatesAreImmediate = false;
+        if (localBiome.hasTag(BiomeTags.HAS_SURFACE_SNOW) && yy > 0 && yy < this.world.getHeightBlocks()) {
+            if (this.world.isAirBlock(xx, yy, zz) && this.world.getBlockMaterial(xx, yy - 1, zz).blocksMotion()) {
+                this.world.setBlockWithNotify(xx, yy, zz, Blocks.LAYER_SNOW.id());
+            }
+        }
+
+        if (localBiome.hasTag(BiomeTags.HAS_SURFACE_ICE)) {
+            final int oceanFluidId = this.world.getBlockId(xx, oceanY - 1, zz);
+            if (oceanFluidId == Blocks.FLUID_WATER_STILL.id() || oceanFluidId == Blocks.FLUID_WATER_FLOWING.id()) {
+                this.world.setBlockWithNotify(xx, oceanY - 1, zz, Blocks.ICE.id());
+            }
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
index e53cd9eee..5a6d86159 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
@@ -15,6 +15,7 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 
 public class ChunkDecoratorOverworldHell
@@ -107,7 +108,8 @@ public class ChunkDecoratorOverworldHell
                 final int xx = worldX + rand.nextInt(16);
                 final int yy = minY + rand.nextInt(rangeY);
                 final int zz = worldZ + rand.nextInt(16);
-                (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(world, rand, xx, yy, zz);
+                TilePos pos = new TilePos(xx, yy, zz);
+                (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(world, rand, pos);
             }
         });
 
@@ -116,7 +118,8 @@ public class ChunkDecoratorOverworldHell
                 final int xx = worldX + rand.nextInt(16);
                 final int yy = minY + rand.nextInt(rangeY);
                 final int zz = worldZ + rand.nextInt(16);
-                (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(world, rand, xx, yy, zz);
+                TilePos pos = new TilePos(xx, yy, zz);
+                (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(world, rand, pos);
             }
         });
 
@@ -125,7 +128,8 @@ public class ChunkDecoratorOverworldHell
                 final int xx = worldX + rand.nextInt(16);
                 final int yy = minY + rand.nextInt(rangeY);
                 final int zz = worldZ + rand.nextInt(16);
-                (new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16)).place(world, rand, xx, yy, zz);
+                TilePos pos = new TilePos(xx, yy, zz);
+                (new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16)).place(world, rand, pos);
             }
         });
 
@@ -134,7 +138,8 @@ public class ChunkDecoratorOverworldHell
                 final int xx = worldX + rand.nextInt(16);
                 final int yy = minY + rand.nextInt(rangeY / 2);
                 final int zz = worldZ + rand.nextInt(16);
-                (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(world, rand, xx, yy, zz);
+                TilePos pos = new TilePos(xx, yy, zz);
+                (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(world, rand, pos);
             }
         });
 
@@ -143,7 +148,8 @@ public class ChunkDecoratorOverworldHell
                 final int xx = worldX + rand.nextInt(16);
                 final int yy = minY + rand.nextInt(rangeY / 4);
                 final int zz = worldZ + rand.nextInt(16);
-                (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(world, rand, xx, yy, zz);
+                TilePos pos = new TilePos(xx, yy, zz);
+                (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(world, rand, pos);
             }
         });
 
@@ -152,7 +158,8 @@ public class ChunkDecoratorOverworldHell
                 final int xx = worldX + rand.nextInt(16);
                 final int yy = minY + rand.nextInt(rangeY / 8);
                 final int zz = worldZ + rand.nextInt(16);
-                (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(world, rand, xx, yy, zz);
+                TilePos pos = new TilePos(xx, yy, zz);
+                (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(world, rand, pos);
             }
         });
 
@@ -161,7 +168,8 @@ public class ChunkDecoratorOverworldHell
                 final int xx = worldX + rand.nextInt(16);
                 final int yy = minY + rand.nextInt(rangeY / 8);
                 final int zz = worldZ + rand.nextInt(16);
-                (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(world, rand, xx, yy, zz);
+                TilePos pos = new TilePos(xx, yy, zz);
+                (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(world, rand, pos);
             }
         });
 
@@ -170,7 +178,8 @@ public class ChunkDecoratorOverworldHell
                 final int xx = worldX + rand.nextInt(16);
                 final int yy = minY + rand.nextInt(rangeY / 8) + rand.nextInt(rangeY / 8);
                 final int zz = worldZ + rand.nextInt(16);
-                (new WorldFeatureOre(BlockLogicOreLapis.variantMap, 6)).place(world, rand, xx, yy, zz);
+                TilePos pos = new TilePos(xx, yy, zz);
+                (new WorldFeatureOre(BlockLogicOreLapis.variantMap, 6)).place(world, rand, pos);
             }
         });
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
index adf3fd0ff..b70de55bf 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld.retro;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.BlockLogicOreCoal;
 import net.minecraft.core.block.BlockLogicOreDiamond;
 import net.minecraft.core.block.BlockLogicOreGold;
@@ -16,12 +18,16 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
 
 import java.util.Random;
 
 public class ChunkDecoratorOverworldRetro
     implements ChunkDecorator {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
+
     private final @NotNull World world;
     private final @NotNull FractalNoise2D<ImprovedPerlinNoise> treeDensityNoise;
 
@@ -38,20 +44,25 @@ public class ChunkDecoratorOverworldRetro
     @Override
     public void decorate(@NotNull Chunk chunk) {
         this.world.scheduledUpdatesAreImmediate = true;
-        int chunkX = chunk.pos.x;
-        int chunkZ = chunk.pos.z;
+        BlockLogicFallingBlock.fallInstantly = true;
+
+        final int chunkX = chunk.pos.x;
+        final int chunkZ = chunk.pos.z;
+
+        try {
 
         int minY = this.world.getWorldType().getMinY(world);
         int maxY = this.world.getWorldType().getMaxY(world);
         int rangeY = (maxY + 1) - minY;
 
-        BlockLogicFallingBlock.fallInstantly = true;
         int k = chunkX * 16;
         int l = chunkZ * 16;
         Random rand = new Random(this.world.getRandomSeed());
         long l1 = (rand.nextLong() / 2L) * 2L + 1L;
         long l2 = (rand.nextLong() / 2L) * 2L + 1L;
         rand.setSeed((long) chunkX * l1 + (long) chunkZ * l2 ^ this.world.getRandomSeed());
+
+        try {
         for (int i1 = 0; i1 < 8; i1++) {
             int i4 = k + rand.nextInt(16) + 8;
             int j6 = minY + rand.nextInt(rangeY);
@@ -70,51 +81,60 @@ public class ChunkDecoratorOverworldRetro
             int k4 = k + rand.nextInt(16);
             int l6 = minY + rand.nextInt(rangeY);
             int k11 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(this.world, rand, k4, l6, k11);
+            TilePos queryPos = new TilePos(k4, l6, k11);
+            (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(this.world, rand, queryPos);
         }
 
         for (int i2 = 0; i2 < 10; i2++) {
             int l4 = k + rand.nextInt(16);
             int i7 = minY + rand.nextInt(rangeY);
             int l11 = l + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(this.world, rand, l4, i7, l11);
+            TilePos queryPos = new TilePos(l4, i7, l11);
+            (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(this.world, rand, queryPos);
         }
 
         for (int j2 = 0; j2 < 20; j2++) {
             int i5 = k + rand.nextInt(16);
             int j7 = minY + rand.nextInt(rangeY);
             int i12 = l + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16)).place(this.world, rand, i5, j7, i12);
+            TilePos queryPos = new TilePos(i5, j7, i12);
+            (new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16)).place(this.world, rand, queryPos);
         }
 
         for (int k2 = 0; k2 < 20; k2++) {
             int j5 = k + rand.nextInt(16);
             int k7 = minY + rand.nextInt(rangeY / 2);
             int j12 = l + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(this.world, rand, j5, k7, j12);
+            TilePos queryPos = new TilePos(j5, k7, j12);
+            (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(this.world, rand, queryPos);
         }
 
         for (int i3 = 0; i3 < 2; i3++) {
             int k5 = k + rand.nextInt(16);
             int l7 = minY + rand.nextInt(rangeY / 4);
             int k12 = l + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(this.world, rand, k5, l7, k12);
+            TilePos queryPos = new TilePos(k5, l7, k12);
+            (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(this.world, rand, queryPos);
         }
 
         for (int j3 = 0; j3 < 8; j3++) {
             int l5 = k + rand.nextInt(16);
             int i8 = minY + rand.nextInt(rangeY / 8);
             int l12 = l + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(this.world, rand, l5, i8, l12);
+            TilePos queryPos = new TilePos(l5, i8, l12);
+            (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(this.world, rand, queryPos);
         }
 
         for (int k3 = 0; k3 < 1; k3++) {
             int i6 = k + rand.nextInt(16);
             int j8 = minY + rand.nextInt(rangeY / 8);
             int i13 = l + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(this.world, rand, i6, j8, i13);
+            TilePos queryPos = new TilePos(i6, j8, i13);
+            (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(this.world, rand, queryPos);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'dungeons_clay_ores' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         double d = 0.5D;
         int l3 = (int) ((this.treeDensityNoise.getValue((double) k * d, (double) l * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
         if (l3 < 0) {
@@ -128,12 +148,18 @@ public class ChunkDecoratorOverworldRetro
             tree = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id());
         }
         for (int k8 = 0; k8 < l3; k8++) {
-            int j13 = k + rand.nextInt(16) + 8;
-            int l15 = l + rand.nextInt(16) + 8;
-            tree.init(1.0D, 1.0D, 1.0D);
-            tree.place(this.world, rand, j13, this.world.getHeightValue(j13, l15), l15);
+            try {
+                int j13 = k + rand.nextInt(16) + 8;
+                int l15 = l + rand.nextInt(16) + 8;
+                tree.init(1.0D, 1.0D, 1.0D);
+                tree.place(this.world, rand, j13, this.world.getHeightValue(j13, l15), l15);
+            } catch (final Throwable treeT) {
+                LOGGER.error("Tree placement #{} failed at chunk ({}, {}); continuing.", k8, chunkX, chunkZ, treeT);
+            }
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'trees' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         for (int l8 = 0; l8 < 2; l8++) {
             int k13 = k + rand.nextInt(16) + 8;
             int i16 = minY + rand.nextInt(rangeY);
@@ -172,7 +198,9 @@ public class ChunkDecoratorOverworldRetro
             int l18 = l + rand.nextInt(16) + 8;
             (new WorldFeatureCactus()).place(this.world, rand, l14, j17, l18);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'flowers_cactus' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         for (int j10 = 0; j10 < 50; j10++) {
             int i15 = k + rand.nextInt(16) + 8;
             int k17 = minY + rand.nextInt(rand.nextInt(rangeY - 8) + 8);
@@ -186,21 +214,65 @@ public class ChunkDecoratorOverworldRetro
             int j19 = l + rand.nextInt(16) + 8;
             (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id())).place(this.world, rand, j15, l17, j19);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'liquids' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
-        for (int l10 = k + 8; l10 < k + 8 + 16; l10++) {
-            for (int k15 = l + 8; k15 < l + 8 + 16; k15++) {
-                int i18 = this.world.findTopSolidBlock(l10, k15);
-                if (this.snowCovered && i18 > minY && i18 <= maxY && this.world.getBlockId(l10, i18, k15) == 0 && this.world.getBlockMaterial(l10, i18 - 1, k15).blocksMotion() && this.world.getBlockMaterial(l10, i18 - 1, k15) != Materials.ICE) {
-                    this.world.setBlockWithNotify(l10, i18, k15, Blocks.LAYER_SNOW.id());
+        // First snow/ice pass
+        try {
+            for (int l10 = k + 8; l10 < k + 8 + 16; l10++) {
+                for (int k15 = l + 8; k15 < l + 8 + 16; k15++) {
+                    try {
+                        applySnowAndIceForColumn(l10, k15, minY, maxY);
+                    } catch (final Throwable colT) {
+                        LOGGER.error("Snow/ice column ({}, {}) failed at chunk ({}, {}); continuing.", l10, k15, chunkX, chunkZ, colT);
+                    }
                 }
-                if (this.snowCovered && this.world.getBlockMaterial(l10, this.world.getWorldType().getOceanY() - 1, k15) == Materials.WATER) {
-                    this.world.setBlockWithNotify(l10, this.world.getWorldType().getOceanY() - 1, k15, Blocks.ICE.id());
+            }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'snow_ice' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
+
+        // Snow/ice repass
+        try {
+            for (int dx = k; dx < k + 32; dx++) {
+                for (int dz = l; dz < l + 32; dz++) {
+                    final int ownerChunkX = (dx - 8) >> 4;
+                    final int ownerChunkZ = (dz - 8) >> 4;
+                    if (ownerChunkX == chunkX && ownerChunkZ == chunkZ) { continue; }
+                    if (!this.world.isChunkLoaded(ownerChunkX, ownerChunkZ)) { continue; }
+                    final Chunk owner = this.world.getChunkFromChunkCoords(ownerChunkX, ownerChunkZ);
+                    if (!owner.isTerrainPopulated) { continue; }
+                    final int physicalChunkX = dx >> 4;
+                    final int physicalChunkZ = dz >> 4;
+                    if (!this.world.isChunkLoaded(physicalChunkX, physicalChunkZ)) { continue; }
+                    try {
+                        applySnowAndIceForColumn(dx, dz, minY, maxY);
+                    } catch (final Throwable colT) {
+                        LOGGER.error("Spillover snow/ice column ({}, {}) failed at chunk ({}, {}); continuing.", dx, dz, chunkX, chunkZ, colT);
+                    }
                 }
             }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'snow_ice_spillover' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        } finally {
+            BlockLogicFallingBlock.fallInstantly = false;
+            this.world.scheduledUpdatesAreImmediate = false;
         }
+    }
+
+    /**
+     * Places snow on the topmost surface of the column, plus ice on top of water at the ocean surface.
+     */
+    private void applySnowAndIceForColumn(final int dx, final int dz, final int minY, final int maxY) {
+        if (!this.snowCovered) { return; }
+
+        final int topY = this.world.findTopSolidBlock(dx, dz);
 
-        BlockLogicFallingBlock.fallInstantly = false;
-        this.world.scheduledUpdatesAreImmediate = false;
+        if (topY > minY && topY <= maxY && this.world.getBlockId(dx, topY, dz) == 0
+                && this.world.getBlockMaterial(dx, topY - 1, dz).blocksMotion()
+                && this.world.getBlockMaterial(dx, topY - 1, dz) != Materials.ICE) {
+            this.world.setBlockWithNotify(dx, topY, dz, Blocks.LAYER_SNOW.id());
+        }
+
+        if (this.world.getBlockMaterial(dx, this.world.getWorldType().getOceanY() - 1, dz) == Materials.WATER) {
+            this.world.setBlockWithNotify(dx, this.world.getWorldType().getOceanY() - 1, dz, Blocks.ICE.id());
+        }
     }
 }
